var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import { jsx as _jsx } from "react/jsx-runtime";
import * as React from 'react';
import classNames from 'classnames';
import useStaticCallback from "../../hooks/useStaticCallback";
import formateOptions from "../_utils/formateOptions";
import { RadioMemo as Radio } from "./Radio";
import { RadioButtonMemo as RadioButton } from "./RadioButton";
import { RadioNavMemo as RadioNav } from "./RadioNav";
var prefixCls = 'dmc-radio-group';
var RadioGroup = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var type = props.type,
      size = props.size,
      _a = props.options,
      options = _a === void 0 ? [] : _a,
      _b = props.valueKey,
      valueKey = _b === void 0 ? 'value' : _b,
      _c = props.labelKey,
      labelKey = _c === void 0 ? 'label' : _c,
      onChange = props.onChange,
      defaultValue = props.defaultValue,
      value = props.value,
      disabled = props.disabled,
      className = props.className,
      itemClassName = props.itemClassName,
      renderItem = props.renderItem,
      radioType = props.radioType,
      restProps = __rest(props, ["type", "size", "options", "valueKey", "labelKey", "onChange", "defaultValue", "value", "disabled", "className", "itemClassName", "renderItem", "radioType"]);

  var _d = React.useState(defaultValue || ''),
      unControlVal = _d[0],
      setUnControlVal = _d[1];

  var opts = React.useMemo(function () {
    return formateOptions(options, labelKey, valueKey);
  }, [options, labelKey, valueKey]);
  var isControl = ('value' in props);
  var val = isControl ? value : unControlVal;
  var onRadioChange = useStaticCallback(function (value) {
    !isControl && setUnControlVal(value);
    onChange && onChange(value);
  });
  var isButton = radioType === 'button';
  var isNav = radioType === 'nav';
  var View = isButton ? RadioButton : isNav ? RadioNav : Radio;
  var wrapperCls = classNames(prefixCls, {
    'dmc-radio-button-group': isButton,
    'dmc-radio-nav-group': isNav
  }, className);
  return _jsx("div", __assign({}, restProps, {
    className: wrapperCls,
    ref: ref
  }, {
    children: opts.map(function (it) {
      var vk = it[valueKey];
      var buttonProps = isButton ? {
        onlyIcon: it.onlyIcon,
        leftIcon: it.leftIcon,
        rightIcon: it.rightIcon
      } : {};
      return _jsx(View, __assign({
        value: vk,
        type: type,
        size: size,
        checked: vk === val,
        onChange: onRadioChange,
        className: itemClassName,
        disabled: it.disabled || disabled,
        icon: it.icon
      }, buttonProps, {
        children: renderItem ? renderItem(it) : it[labelKey]
      }), vk);
    })
  }), void 0);
});
RadioGroup.defaultProps = {
  options: [],
  labelKey: 'label',
  valueKey: 'value'
};
var RadioGroupMemo = /*#__PURE__*/React.memo(RadioGroup);
RadioGroupMemo.displayName = 'RadioGroupMemo';
export { RadioGroupMemo };
RadioGroup.displayName = 'RadioGroup';
export default RadioGroup;

